#include <jni.h>
#include <time.h>
#include <android/log.h>
#include <android/bitmap.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>



#include "wintypes.h"
#include "qbist.h"



#define  LOG_TAG    "libqbist"
#define  LOGI(...)  __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)
#define  LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)



// From ftp://ftp.heise.de/pub/ct/listings/ct9510.zip
void MakeVariations(short coarseness)
{
	short variation, i;
    LOGI("MakeVariations(%i)", coarseness);
	for(variation = 1; variation <=8; variation++)
		for(i=0; i<NUM_TRANSFORMS;i++)
		{
			transformSequence[variation][i]=transformSequence[0][i];
			source[variation][i]=source[0][i];
			control[variation][i]=control[0][i];
			dest[variation][i]=dest[0][i];
		}

	for(variation = 1; variation <=8; variation++)
	{
		/*switch(coarseness)
		{
			case 2:
				transformSequence[variation][myRand()%NUM_TRANSFORMS]=myRand()%TOTAL_TRANSFORMS;
				source[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
				control[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
				dest[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
			 	//Kein break!
			case 1:
				transformSequence[variation][myRand()%NUM_TRANSFORMS]=myRand()%TOTAL_TRANSFORMS;
				source[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
				control[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
				dest[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
		 		break;
			case 0:*/
		for(i=0; i<coarseness; i++)
				switch(myRand()%4)
				{
					case 0:
						transformSequence[variation][myRand()%NUM_TRANSFORMS]=myRand()%TOTAL_TRANSFORMS;
						break;
					case 1:
						source[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
						break;
					case 2:
						control[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
						break;
					case 3:
						dest[variation][myRand()%NUM_TRANSFORMS]=myRand()%NUM_REGISTERS;
						break;
				}
				/*break;
		}*/
	}
}


void OnNewDocument()
{
    LOGI("OnNewDocument()");
	for(int i=0;i<NUM_TRANSFORMS;i++)
	{
		transformSequence[0][i] = myRand()%TOTAL_TRANSFORMS;
		source[0][i] = myRand()%NUM_REGISTERS;
		control[0][i] = myRand()%NUM_REGISTERS;
		dest[0][i] = myRand()%NUM_REGISTERS;
	}
	//coarseness=1;

	MakeVariations(4);
}



extern "C" {

JNIEXPORT void JNICALL Java_de_killig_qbist_QbistView_OnNewDocument(JNIEnv * env, jobject obj) {
	OnNewDocument();
}


JNIEXPORT void JNICALL Java_de_killig_qbist_QbistView_MakeVariations(JNIEnv * env, jobject obj, short coarseness) {
	MakeVariations(coarseness);
}


/*JNIEXPORT void JNICALL Java_de_killig_qbist_QbistView_SwitchCoarseness(JNIEnv * env, jobject obj, short newCoarseness)
{
    LOGI("SwitchCoarseness(%i)", newCoarseness);
	coarseness = newCoarseness;
}*/


JNIEXPORT void JNICALL Java_de_killig_qbist_QbistView_variationAsMain(JNIEnv * env, jobject obj, short variation, short coarseness)
{
    LOGI("variationAsMain(%i)", variation);
	for(int i=0;i<NUM_TRANSFORMS;i++)
	{
		transformSequence[0][i] = transformSequence[variation][i];
		source[0][i] = source[variation][i];
		control[0][i] = control[variation][i];
		dest[0][i] = dest[variation][i];
	}
	MakeVariations(coarseness);
//	UpdateAllViews(NULL, 0L, NULL);
}


JNIEXPORT void JNICALL Java_de_killig_qbist_QbistView_Serialize(JNIEnv * env, jobject obj, jbyteArray ja)
{
	int i,j=0;
	jbyte ar[NUM_TRANSFORMS*4];
		//ACHTUNG: MOTOROLA-BYTEFOLGE
		for(i = 0; i<NUM_TRANSFORMS; i++)
	    	ar[j++]=transformSequence[0][i];
		for(i = 0; i<NUM_TRANSFORMS; i++)
			ar[j++]=source[0][i];
		for(i = 0; i<NUM_TRANSFORMS; i++)
			ar[j++]=control[0][i];
		for(i = 0; i<NUM_TRANSFORMS; i++)
			ar[j++]=dest[0][i];
		env->SetByteArrayRegion(ja, 0, sizeof(ar)/sizeof(jbyte), ar);
}


JNIEXPORT void JNICALL Java_de_killig_qbist_QbistView_renderQbist(JNIEnv * env, jobject obj, jobject bitmap, jlong time_ms, int gVariation)
{
    AndroidBitmapInfo  info;
    void*              pixels;
    int                ret;

    LOGI("renderQbist(,,%i)", gVariation);

    if ((ret = AndroidBitmap_getInfo(env, bitmap, &info)) < 0) {
        LOGE("AndroidBitmap_getInfo() failed ! error=%d", ret);
        return;
    }

    if (info.format != ANDROID_BITMAP_FORMAT_RGBA_8888) {
        LOGE("Bitmap format is not ANDROID_BITMAP_FORMAT_RGBA_8888 !");
        return;
    }

    if ((ret = AndroidBitmap_lockPixels(env, bitmap, &pixels)) < 0) {
        LOGE("AndroidBitmap_lockPixels() failed ! error=%d", ret);
    }

myDraw(&info, pixels, gVariation);

    AndroidBitmap_unlockPixels(env, bitmap);
}


}



#ifdef HAVE_NEON
#include <arm_neon.h>
// From http://stackoverflow.com/questions/1854254/fast-sine-cosine-for-armv7neon-looking-for-testers
/// Computes the sine and cosine of two angles
/// in: angles = Two angles, expressed in radians, in the [-PI,PI] range.
/// out: results = vector containing [sin(angles[0]),cos(angles[0]),sin(angles[1]),cos(angles[1])]
static inline void vsincos(const float angles[2], float results[4]) {
    static const float constants[]  = {
    /* q1 */  0,                M_PI_2,           0,                M_PI_2,
    /* q2 */  M_PI,             M_PI,             M_PI,             M_PI,
    /* q3 */  4.f/M_PI,         4.f/M_PI,         4.f/M_PI,         4.f/M_PI,
    /* q4 */ -4.f/(M_PI*M_PI), -4.f/(M_PI*M_PI), -4.f/(M_PI*M_PI), -4.f/(M_PI*M_PI),
    /* q5 */  2.f,              2.f,              2.f,              2.f,
    /* q6 */  .225f,            .225f,            .225f,            .225f
    };
    asm volatile(
        // Load q0 with [angle1,angle1,angle2,angle2]
        "vldmia %1, { d3 }\n\t"
        "vdup.f32 d0, d3[0]\n\t"
        "vdup.f32 d1, d3[1]\n\t"
        // Load q1-q6 with constants
        "vldmia %2, { q1-q6 }\n\t"
        // Cos(x) = Sin(x+PI/2), so
        // q0 = [angle1, angle1+PI/2, angle2, angle2+PI/2]
        "vadd.f32 q0,q0,q1\n\t"
        // if angle1+PI/2>PI, substract 2*PI
        // q0-=(q0>PI)?2*PI:0
        "vcge.f32 q1,q0,q2\n\t"
        "vand.f32 q1,q1,q2\n\t"
        "vmls.f32 q0,q1,q5\n\t"
        // q0=(4/PI)*q0 - q0*abs(q0)*4/(PI*PI)
        "vabs.f32 q1,q0\n\t"
        "vmul.f32 q1,q0,q1\n\t"
        "vmul.f32 q0,q0,q3\n\t"
        "vmul.f32 q1,q1,q4\n\t"
        "vadd.f32 q0,q0,q1\n\t"
        // q0+=.225*(q0*abs(q0) - q0)
        "vabs.f32 q1,q0\n\t"
        "vmul.f32 q1,q0,q1\n\t"
        "vsub.f32 q1,q0\n\t"
        "vmla.f32 q0,q1,q6\n\t"
        "vstmia %0, { q0 }\n\t"
        :: "r"(results), "r"(angles), "r"(constants)
        : "memory","cc","q0","q1","q2","q3","q4","q5","q6"
    );
}
#endif



unsigned short initSeed(void) {
    LOGI("initSeed()");
    srand ( time(NULL) );
	return rand()/*%65536*/;
}


unsigned short myRand (void)
{
	/*static unsigned short seed;
	long myTime;

	time(&myTime);
	seed = 1237*seed+359+(myTime & 17);
    LOGI("myRand(%i): ", seed);
	return seed;*/
	static unsigned short seed=initSeed();
	return rand()%65535;
}

void projection (myVector *source, myVector *control, myVector *dest)
{
	float scalarProd;

	scalarProd = source->x*control->x+source->y*control->y+source->z*control->z;
	dest->x = scalarProd*source->x;
	dest->y = scalarProd*source->y;
	dest->z = scalarProd*source->z;
}

void shift (myVector *source, myVector *control, myVector *dest)
{
	dest->x = source->x+control->x;
	if (dest->x >= 1.0)
		dest->x -= 1.0F;
	dest->y = source->y+control->y;
	if (dest->y >= 1.0)
		dest->y -= 1.0F;
	dest->z = source->z+control->z;
	if (dest->z >= 1.0)
		dest->z -= 1.0F;
}

void shiftBack (myVector *source, myVector *control, myVector *dest)
{
	dest->x = source->x-control->x;
	if (dest->x <= 0.0)
		dest->x += 1.0F;
	dest->y = source->y-control->y;
	if (dest->y <= 0.0)
		dest->y += 1.0F;
	dest->z = source->z-control->z;
	if (dest->z <= 0.0)
		dest->z += 1.0F;
}

void rotate (myVector *source, myVector *control, myVector *dest)
{
	dest->x = source->y;
	dest->y = source->z;
	dest->z = source->x;
}

void rotate2 (myVector *source, myVector *control, myVector *dest)
{
	dest->x = source->z;
	dest->y = source->x;
	dest->z = source->y;
}

void multiply (myVector *source, myVector *control, myVector *dest)
{
	dest->x = source->x*control->x;
	dest->y = source->y*control->y;
	dest->z = source->z*control->z;
}

float sinf_(float v) {
	if(v<-M_PI || v>M_PI) LOGI("sinf_ out of range!");
	return sinf(v);
}

void sine (myVector *source, myVector *control, myVector *dest)
{
#ifdef HAVE_NEON_disabled
	float angles[2];
	float results[4];
	angles[0]=20.0F*source->x*control->x;
	angles[1]=20.0F*source->y*control->y;
	vsincos(angles, results);
	dest->x = 0.5F+0.5F*results[0];
	dest->y = 0.5F+0.5F*results[2];

	angles[0]=20.0F*source->z*control->z;
	vsincos(angles, results);
	dest->z = 0.5F+0.5F*results[0];
#else
	dest->x = 0.5F+0.5F*sinf(20.0F*source->x*control->x);
	dest->y = 0.5F+0.5F*sinf(20.0F*source->y*control->y);
	dest->z = 0.5F+0.5F*sinf(20.0F*source->z*control->z);
#endif
}

void conditional (myVector *source, myVector *control, myVector *dest)
{
	if(control->x+control->y+control->z >0.5)
	{
		dest->x = source->x;
		dest->y = source->y;
		dest->z = source->z;
	}
	else
	{
		dest->x = control->x;
		dest->y = control->y;
		dest->z = control->z;
	}
}

void complement (myVector *source, myVector *control, myVector *dest)
{
	dest->x = 1.0F-source->x;
	dest->y = 1.0F-source->y;
	dest->z = 1.0F-source->z;
}


// From http://git.gnome.org/browse/gimp/tree/plug-ins/common/qbist.c#n168
// Optimizer
typedef int gint;
/*static*/ bool used_trans_flag[9][NUM_TRANSFORMS];
/*static*/ void check_last_modified (int gVariation, gint p, gint n) {
  p--;
  while ((p >= 0) && (dest[gVariation][p] != n))
    p--;
  if (p < 0)
    {}
  else
    {
      used_trans_flag[gVariation][p] = true;
      check_last_modified (gVariation, p, source[gVariation][p]);
      check_last_modified (gVariation, p, control[gVariation][p]);
    }
}

/*static*/ void optimize (int gVariation) {
  gint i;

  for (i = 0; i < NUM_TRANSFORMS; i++)
    {
      used_trans_flag[gVariation][i] = false;
      /* double-arg fix: */
      switch (transformSequence[gVariation][i])
        {
        case 3:
        case 4:
        case 8:
          control[gVariation][i] = dest[gVariation][i];
          break;

        default:
          break;
        }
    }
  /* check for last modified item */
  check_last_modified (gVariation, NUM_TRANSFORMS, 0);
}


void myDraw(AndroidBitmapInfo*  info, void*  pixels, /*BOOL fromStart*/int gVariation)
{
    LOGI("myDraw(,,%i); stride: %i", gVariation, info->stride);

    myVector reg[NUM_REGISTERS];

    int x,y=0,i,j;


    LOGI("transen");
    bool transenMerge[NUM_TRANSFORMS];
    char transen[NUM_TRANSFORMS+1];
    transen[NUM_TRANSFORMS]=0;

    // From Horst Klier:
    bool iReg[NUM_REGISTERS];
    bool Tranlist_needed[NUM_TRANSFORMS];
    iReg[0]=true;
    iReg[1]=iReg[2]=iReg[3]=iReg[4]=iReg[5]=false;
    for(j=NUM_TRANSFORMS-1; j>=0; j--){
        if(!iReg[dest[gVariation][j]]){ // Unntig
            Tranlist_needed[j]=false;
        }else{
        	Tranlist_needed[j]=true;
            iReg[dest[gVariation][j]]=false;
            iReg[source[gVariation][j]]=true;
            iReg[control[gVariation][j]]=true;
        }
    }

    for(j=0; j<NUM_TRANSFORMS; j++) {
    	if(Tranlist_needed[j]) transen[j]='#';
    	else transen[j]='.';
    }
    LOGI("transen: Horst: %s", transen);


    optimize(gVariation);

    for(j=0; j<NUM_TRANSFORMS; j++) {
    	if(used_trans_flag[gVariation][j]) transen[j]='#';
    	else transen[j]='.';
    }
    LOGI("transen: GIMP:  %s", transen);


    // Until I know who's right:
    for(j=0; j<NUM_TRANSFORMS; j++) transenMerge[j]=Tranlist_needed[j] || used_trans_flag[gVariation][j];

    for(j=0; j<NUM_TRANSFORMS; j++) {
    	if(transenMerge[j]) transen[j]='#';
    	else transen[j]='.';
    }
    LOGI("transen: merge: %s", transen);


	// Optimization
    float /*reg_x,*/regY;
	float regJ[NUM_REGISTERS];
	for(j=0; j<NUM_REGISTERS; j++) regJ[j] = ((float)j)/(float)NUM_REGISTERS;
	float* regX=new float[info->width];
	for(x=0; x<info->width; x++) regX[x] = ((float)x)/(float)(info->width-1);

	uint32_t*  line;
	for(y=0;y<info->height;y++)
	{
		regY=((float)y)/(float)(info->height-1);
		line = ((uint32_t*)pixels) + y*(info->stride/4);
		for(x=0;x<info->width;x++)
		{
			//reg_x=((float)x)/(float)(info->width-1);

			for(j=0; j<NUM_REGISTERS; j++)
			{
				reg[j].x = regX[x];
				reg[j].y = regY;
				reg[j].z = regJ[j];
			}

			for(i=0;i<NUM_TRANSFORMS; i++)
			{
				if(transenMerge[i]) {
					transformList[transformSequence[gVariation][i]]
						(&(reg[source[gVariation][i]]),
						 &(reg[control[gVariation][i]]),
						 &(reg[dest[gVariation][i]]));
				}
			}

			line[x]=ARGB((BYTE)(0xFE * reg[0].x),(BYTE)(0xFE * reg[0].y),(BYTE)(0xFE * reg[0].z) );
		}
	}
	delete[] regX;
}
